/* Sistemas Integrados TECNISA

Nome: 9812_CDPTRGO_LOG_CDP_COMPPROD.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   17/02/2009 - Henrique Guidi Lobato
*/

/* Tabela COMPPROD.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              COMPPROD, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_CDP_COMPPROD
AFTER DELETE OR INSERT OR UPDATE
ON COMPPROD FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH  FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';  
   V_CONT_LENGTH  := 1;
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;

         IF :NEW.CDESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:NEW.CDESPEPROD,'') || ' ';
         END IF;

         IF :NEW.CDTIPOCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoComposicao= ' || NVL(:NEW.CDTIPOCOMP,'') || ' ';
         END IF;
         
         IF :NEW.CDPRODINSUMO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProdInsumo= ' || NVL(:NEW.CDPRODINSUMO,'') || ' ';
         END IF;

         IF :NEW.IDUTAPROVREQ IS NOT NULL THEN
         V_DESC := V_DESC || 'IdUtProdLoteCalcReq= ' || NVL(:NEW.IDUTAPROVREQ,'') || ' ';
         END IF;  
         
         IF :NEW.QTINSUMO IS NOT NULL THEN
            V_DESC := V_DESC || 'QtInsumo= ' || NVL(TO_CHAR(:NEW.QTINSUMO),'') || ' ';
         END IF;
         
         IF :NEW.CDTIPOINSU IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoInsumo= ' || :NEW.CDTIPOINSU || ' ';
         END IF;         

         IF :NEW.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'SiglaUnidade= ' || :NEW.SGUNIDADE || ' ';
         END IF;

         IF :NEW.IDSEMIACCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'IdProdSemi-Acabado= ' || :NEW.IDSEMIACCOMP || ' ';
         END IF;

         IF :NEW.IDUTILOTEPR IS NOT NULL THEN
            V_DESC := V_DESC || 'IdUtilizacaoLote= ' || :NEW.IDUTILOTEPR || ' ';
         END IF;

         IF :NEW.CDPRODUTOAUX IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProdutoAuxiliar= ' || :NEW.CDPRODUTOAUX || ' ';
         END IF;

         IF :NEW.CDESPPRODAUX IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecifiProdAux= ' || :NEW.CDESPPRODAUX || ' ';
         END IF;

         IF :NEW.NRORDCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdemComposi= ' || :NEW.NRORDCOMP || ' ';
         END IF;

         IF :NEW.TXCOMITCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'TxComentItemComposi= ' || :NEW.TXCOMITCOMP || ' ';
         END IF;

         IF :NEW.IDIMPCOMPDEL IS NOT NULL THEN
            V_DESC := V_DESC || 'IdImpressoDelivery= ' || :NEW.IDIMPCOMPDEL || ' ';
         END IF;
         
         IF :NEW.VRLOADCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'VrLoadingComposicao.= ' || TO_CHAR(:NEW.VRLOADCOMP) || ' ';
         END IF;

         IF :NEW.DSLOADCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'DsLoadingComposicao= ' || :NEW.DSLOADCOMP || ' ';
         END IF;

         IF :NEW.QTBRUTINSPRO IS NOT NULL THEN
            V_DESC := V_DESC || 'QtBurtaInsumoProduc= ' || TO_CHAR(:NEW.QTBRUTINSPRO) || ' ';
         END IF;

         IF :NEW.VRPRENDINSPR IS NOT NULL THEN
            V_DESC := V_DESC || 'VrPercentRendimentoProd= ' || TO_CHAR(:NEW.VRPRENDINSPR) || ' ';
         END IF;

         IF :NEW.VRCUSTPRODMM IS NOT NULL THEN
            V_DESC := V_DESC || 'VrCustoProducMin= ' || TO_CHAR(:NEW.VRCUSTPRODMM) || ' ';
         END IF;

         IF :NEW.VRCUSTEQUIMM IS NOT NULL THEN
            V_DESC := V_DESC || 'VrCustEquipMin= ' || TO_CHAR(:NEW.VRCUSTEQUIMM) || ' ';
         END IF;

         IF :NEW.VRCUSTRDELMM IS NOT NULL THEN
            V_DESC := V_DESC || 'VrCustRampDeliveryMin= ' || TO_CHAR(:NEW.VRCUSTRDELMM) || ' ';
         END IF;
                  
      V_ITPESQ := :NEW.CDPRODUTO    || :NEW.CDESPEPROD || :NEW.CDTIPOCOMP || :NEW.CDPRODINSUMO;
                  
      V_IDTIPOOPER := '1';  

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDPRODUTO <> :OLD.CDPRODUTO) THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:NEW.CDPRODUTO,'') || ' ';
         END IF;

         IF (:NEW.CDESPEPROD <> :OLD.CDESPEPROD) THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:NEW.CDESPEPROD,'') || ' ';
         END IF;

         IF (:NEW.CDTIPOCOMP <> :OLD.CDTIPOCOMP) THEN
            V_DESC := V_DESC || 'CdTipoComposicao= ' || NVL(:NEW.CDTIPOCOMP,'') || ' ';
         END IF;
         
         IF (:NEW.CDPRODINSUMO <> :OLD.CDPRODINSUMO) THEN
            V_DESC := V_DESC || 'CdProdInsumo= ' || NVL(:NEW.CDPRODINSUMO,'') || ' ';
         END IF;

         IF (:NEW.IDUTAPROVREQ <> :OLD.IDUTAPROVREQ) THEN
         V_DESC := V_DESC || 'IdUtProdLoteCalcReq= ' || NVL(:NEW.IDUTAPROVREQ,'') || ' ';
         END IF;  
         
         IF (:NEW.QTINSUMO <> :OLD.QTINSUMO) THEN
            V_DESC := V_DESC || 'QtInsumo= ' || NVL(TO_CHAR(:NEW.QTINSUMO),'') || ' ';
         END IF;
         
         IF (NVL(:NEW.CDTIPOINSU,'-1') <> NVL(:OLD.CDTIPOINSU,'-1')) THEN
            V_DESC := V_DESC || 'CdTipoInsumo= ' || :NEW.CDTIPOINSU || ' ';
         END IF;         

         IF (NVL(:NEW.SGUNIDADE,'-1') <> NVL(:OLD.SGUNIDADE,'-1')) THEN
            V_DESC := V_DESC || 'SiglaUnidade= ' || :NEW.SGUNIDADE || ' ';
         END IF;

         IF (NVL(:NEW.IDSEMIACCOMP,'-1') <> NVL(:OLD.IDSEMIACCOMP,'-1')) THEN
            V_DESC := V_DESC || 'IdProdSemi-Acabado= ' || :NEW.IDSEMIACCOMP || ' ';
         END IF;

         IF (NVL(:NEW.IDUTILOTEPR,'-1') <> NVL(:OLD.IDUTILOTEPR,'-1')) THEN
            V_DESC := V_DESC || 'IdUtilizacaoLote= ' || :NEW.IDUTILOTEPR || ' ';
         END IF;

         IF (NVL(:NEW.CDPRODUTOAUX,'-1') <> NVL(:OLD.CDPRODUTOAUX,'-1')) THEN
            V_DESC := V_DESC || 'CdProdutoAuxiliar= ' || :NEW.CDPRODUTOAUX || ' ';
         END IF;

         IF (NVL(:NEW.CDESPPRODAUX,'-1') <> NVL(:OLD.CDESPPRODAUX,'-1')) THEN
            V_DESC := V_DESC || 'CdEspecifiProdAux= ' || :NEW.CDESPPRODAUX || ' ';
         END IF;

         IF (NVL(:NEW.NRORDCOMP,'-1') <> NVL(:OLD.NRORDCOMP,'-1')) THEN
            V_DESC := V_DESC || 'NrOrdemComposi= ' || :NEW.NRORDCOMP || ' ';
         END IF;

         IF (NVL(:NEW.TXCOMITCOMP,'-1') <> NVL(:OLD.TXCOMITCOMP,'-1')) THEN
            V_DESC := V_DESC || 'TxComentItemComposi= ' || :NEW.TXCOMITCOMP || ' ';
         END IF;

         IF (NVL(:NEW.IDIMPCOMPDEL,'-1') <> NVL(:OLD.IDIMPCOMPDEL,'-1')) THEN
            V_DESC := V_DESC || 'IdImpressoDelivery= ' || :NEW.IDIMPCOMPDEL || ' ';
         END IF;
         
         IF (NVL(:NEW.VRLOADCOMP,'-1') <> NVL(:OLD.VRLOADCOMP,'-1')) THEN
            V_DESC := V_DESC || 'VrLoadingComposicao.= ' || TO_CHAR(:NEW.VRLOADCOMP) || ' ';
         END IF;

         IF (NVL(:NEW.DSLOADCOMP,'-1') <> NVL(:OLD.DSLOADCOMP,'-1')) THEN
            V_DESC := V_DESC || 'DsLoadingComposicao= ' || :NEW.DSLOADCOMP || ' ';
         END IF;

         IF (NVL(:NEW.QTBRUTINSPRO,'-1') <> NVL(:OLD.QTBRUTINSPRO,'-1')) THEN
            V_DESC := V_DESC || 'QtBurtaInsumoProduc= ' || TO_CHAR(:NEW.QTBRUTINSPRO) || ' ';
         END IF;

         IF (NVL(:NEW.VRPRENDINSPR,'-1') <> NVL(:OLD.VRPRENDINSPR,'-1')) THEN
            V_DESC := V_DESC || 'VrPercentRendimentoProd= ' || TO_CHAR(:NEW.VRPRENDINSPR) || ' ';
         END IF;

         IF (NVL(:NEW.VRCUSTPRODMM,'-1') <> NVL(:OLD.VRCUSTPRODMM,'-1')) THEN
            V_DESC := V_DESC || 'VrCustoProducMin= ' || TO_CHAR(:NEW.VRCUSTPRODMM) || ' ';
         END IF;

         IF (NVL(:NEW.VRCUSTEQUIMM,'-1') <> NVL(:OLD.VRCUSTEQUIMM,'-1')) THEN
            V_DESC := V_DESC || 'VrCustEquipMin= ' || TO_CHAR(:NEW.VRCUSTEQUIMM) || ' ';
         END IF;

         IF (NVL(:NEW.VRCUSTRDELMM,'-1') <> NVL(:OLD.VRCUSTRDELMM,'-1')) THEN
            V_DESC := V_DESC || 'VrCustRampDeliveryMin= ' || TO_CHAR(:NEW.VRCUSTRDELMM) || ' ';
         END IF;

      V_ITPESQ := :NEW.CDPRODUTO    || :NEW.CDESPEPROD || :NEW.CDTIPOCOMP || :NEW.CDPRODINSUMO;

          V_IDTIPOOPER := '2';    
          
      END IF; 

   IF DELETING  THEN

         IF :OLD.CDPRODUTO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProd= ' || NVL(:OLD.CDPRODUTO,'') || ' ';
         END IF;

         IF :OLD.CDESPEPROD IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecificProd= ' || NVL(:OLD.CDESPEPROD,'') || ' ';
         END IF;

         IF :OLD.CDTIPOCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoComposicao= ' || NVL(:OLD.CDTIPOCOMP,'') || ' ';
         END IF;
         
         IF :OLD.CDPRODINSUMO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProdInsumo= ' || NVL(:OLD.CDPRODINSUMO,'') || ' ';
         END IF;

         IF :OLD.IDUTAPROVREQ IS NOT NULL THEN
         V_DESC := V_DESC || 'IdUtProdLoteCalcReq= ' || NVL(:OLD.IDUTAPROVREQ,'') || ' ';
         END IF;  
         
         IF :OLD.QTINSUMO IS NOT NULL THEN
            V_DESC := V_DESC || 'QtInsumo= ' || NVL(TO_CHAR(:OLD.QTINSUMO),'') || ' ';
         END IF;
         
         IF :OLD.CDTIPOINSU IS NOT NULL THEN
            V_DESC := V_DESC || 'CdTipoInsumo= ' || :OLD.CDTIPOINSU || ' ';
         END IF;         

         IF :OLD.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'SiglaUnidade= ' || :OLD.SGUNIDADE || ' ';
         END IF;

         IF :OLD.IDSEMIACCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'IdProdSemi-Acabado= ' || :OLD.IDSEMIACCOMP || ' ';
         END IF;

         IF :OLD.IDUTILOTEPR IS NOT NULL THEN
            V_DESC := V_DESC || 'IdUtilizacaoLote= ' || :OLD.IDUTILOTEPR || ' ';
         END IF;

         IF :OLD.CDPRODUTOAUX IS NOT NULL THEN
            V_DESC := V_DESC || 'CdProdutoAuxiliar= ' || :OLD.CDPRODUTOAUX || ' ';
         END IF;

         IF :OLD.CDESPPRODAUX IS NOT NULL THEN
            V_DESC := V_DESC || 'CdEspecifiProdAux= ' || :OLD.CDESPPRODAUX || ' ';
         END IF;

         IF :OLD.NRORDCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'NrOrdemComposi= ' || :OLD.NRORDCOMP || ' ';
         END IF;

         IF :OLD.TXCOMITCOMP IS NOT NULL THEN
            V_DESC := V_DESC || 'TxComentItemComposi= ' || :OLD.TXCOMITCOMP || ' ';
         END IF;
                  
      V_ITPESQ := :OLD.CDPRODUTO    || :OLD.CDESPEPROD || :OLD.CDTIPOCOMP || :OLD.CDPRODINSUMO;

      V_IDTIPOOPER := '3';
      
   END IF;   

   IF NOT (V_DESC IS NULL) THEN      

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                      VALUES  ('COMPPROD', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC, V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER); 
  
      END LOOP;
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_COMPPROD','5.07.001'); END;
/  
